#include "stdafx.h"

int A[COLS][LINS];
int B[COLS][LINS];

void InitLife(int k) //   (0 - , 1 - )
{
	for (int i=0; i<COLS; i++)
		for (int j=0; j<LINS; j++)
			if (k) A[i][j]=rand()%2;
			else   A[i][j]=0;
}

int Field(int i,int j,int k) //     
//       
//  :
// 0 -  0
// 1 -  1
// 2 -    
//   -   ,    
{
	if (i<0) i+=COLS;	if (i>=COLS) i-=COLS;
	if (j<0) j+=LINS;	if (j>=LINS) j-=LINS;
	switch (k)
	{
	case 0: A[i][j]=0; break;
	case 1: A[i][j]=1; break;
	case 2: if (A[i][j]) A[i][j]=0; else A[i][j]=1; break;
	}
	return A[i][j];
}

int Around(int I, int J) //  
{
	int k = 0;
	for (int i=I-1; i<=I+1; i++)
		for (int j=J-1; j<=J+1; j++)
			if (i!=I || j!=J)
				if (Field(i,j,-1)) k++;
	return k;
}

int Step() //   ,   "" 
{
    int k = 0; //  "" 
    
	for (int i=0; i<COLS; i++)
		for (int j=0; j<LINS; j++)
			switch(Around(i,j))
			{
			case 2: B[i][j]=A[i][j];
				break;
			case 3: B[i][j]=1;
				break;
			default:
				B[i][j]=0;
			}

	for (int i=0; i<COLS; i++)
		for (int j=0; j<LINS; j++)
			if (A[i][j]=B[i][j]) k++;

	return k;
}

void Paint(HDC hdc) //    
{
	HPEN pen, oldpen;
	HBRUSH brush, oldbrush;
   
	pen=CreatePen(PS_SOLID,1,RGB(127,127,127)); 
	oldpen=(HPEN) SelectObject(hdc,pen);

	for (int i=0; i<COLS; i++)
		for (int j=0; j<LINS; j++)
		{	if (A[i][j]) brush=(HBRUSH) GetStockObject(BLACK_BRUSH);
			else		 brush=(HBRUSH) GetStockObject(WHITE_BRUSH);
            oldbrush = (HBRUSH) SelectObject(hdc,brush);
			Rectangle(hdc,i*CELL,j*CELL,i*CELL+CELL,j*CELL+CELL);
			SelectObject(hdc,oldbrush);
		}

    SelectObject(hdc,oldpen);
    DeleteObject(pen);
}
